{$A+,B-,D+,E-,F+,G+,I-,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit loader;
interface
type tblb=array[0..65530] of byte;
pblb=^tblb;
function getdata(i:longint):integer;
function initloader:string;
const size:longint=0;
backward:boolean=false;
implementation
uses dos;

var buf:pblb;
    f:file;
    param:record fs:longint;count:word;bufofs,bufseg:word;end;

const curblock:longint=0;
isfile:boolean=false;
isdisk:boolean=false;disk:byte=255;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{AT help v 1.50                       INT 25                             KeybCS 2
 Vstup ͻ
    AL     slo drive  (0=A, 1=B atd. )              < 32 MB           
    CX     poet sektor ke ten                                       
    DX     logick slo prvnho sektoru ke ten                       
  DS:BX    adresa bufferu                                               
 Vstup ͹ 
    AL     slo drive  (0=A, 1=B atd. )              > 32 MB           
    CX     0FFFFh - znaka >32 MB                                       
  DS:BX    ukazatel na tabulku parametr                                
Ķ 
 Tabulka param :                                                         
    F_Sector DD ? ; Prvn sektor, 32 bitov slo                        
    Count    DW ? ; Poet sektor ke ten                               
    Buffer_o DW ? ; (offset)  Adresa bufferu pro data                    
    Buffer_s DW ? ; (segment)                                            
 Vstup ͹ 
   CF=1    Chyba                                                        
    AX     slo chyby. Viz ne                                        
Ķ 
   CF=0    OK                                                           
Ķ 
}
(*function readfloppy(disk:byte;firstsector:word;buf:pointer):word;
label error;
var oldds:word;
begin
firstsector:=firstsector shl 9;
asm
mov     ax,ds
push    ax
mov     al,disk       {;uri drive A}
mov     dx,firstsector{;uri boot sector DOSu a  BPB - 0}
mov     cx,64         {;nati jeden sektor .. 64}
lds     bx,buf        {; ... do zsobnku na DS:BX}
int     25H
pop     dx            {;vypustit zbyten slovo }
jc      error
end;
firstsector:=firstsector +64;
asm
mov     al,disk       {;uri drive A}
mov     dx,firstsector{;uri boot sector DOSu a  BPB - 0}
mov     cx,64         {;nati jeden sektor .. -1}
lds     bx,buf        {; ... do zsobnku na DS:BX}
add     bx,32768
int     25H
pop     dx            {;vypustit zbyten slovo }
jc      error
xor AX,AX
error:mov firstsector,ax
pop ax
mov ds,ax

end;
readfloppy:=firstsector;
end;*)
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function readdisk(disk:word;firstsector:longint;buf:pointer):word;
{   AL     slo drive  (0=A, 1=B atd. )              > 32 MB           
    CX     0FFFFh - znaka >32 MB                                       
  DS:BX    ukazatel na tabulku parametr                                
Ķ 
 Tabulka param :                                                         
    F_Sector DD ? ; Prvn sektor, 32 bitov slo                        
    Count    DW ? ; Poet sektor ke ten                               
    Buffer_o DW ? ; (offset)  Adresa bufferu pro data                    
    Buffer_s DW ? ; (segment)                                            
}
label error;
var p:pointer;
begin
p:=@param;
with param do begin
fs:=firstsector shl 9;count:=64;bufseg:=seg(buf^);bufofs:=ofs(buf^);
end;
asm
mov     ax,ds
push    ax
mov     ax,disk       {;uri drive A}
lds     bx,p      {; ... parametry na DS:BX}
mov     cx,0FFFFH
int     25H
pop     dx            {;vypustit zbyten slovo }
jc      error
xor     ax,ax
error:mov disk,ax
end;
readdisk:=disk;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure reload(poz:longint);
var i:word;
begin
curblock:=poz;
if curblock > 16384 then dec(curblock,16384);

if isdisk then begin
fillchar(buf^,32768,0);readdisk(disk,curblock shr 9,buf);exit;end;


if isfile then begin
if curblock>size then exit;
seek(f,curblock);
blockread(f,buf^,32768,i);
exit;end;

longint(buf):=((curblock shr 16) shl 28) or (curblock and 65535);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getdata(i:longint):integer;
begin
if backward then i:=size-1-i;
if (i>=size)or(i<0) then begin getdata:=-1;exit;end;
if (i<curblock) or (i-curblock>=32768) then reload(i);
getdata:=buf^[i - curblock];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function initloader:string;
var i:byte;
name:string;
begin
name:=paramstr(1);
isfile:=name<>'';
if (name[0]=#2)and(upcase(name[1])in['A'..'Z'])and(name[2]=':')then
begin isdisk:=true;name[1]:=upcase(name[1]);
      disk:=byte(name[1])-65;size:=disksize(disk+1);
end else size:=1048576;
if isfile and not isdisk then begin
filemode:=0;assign(f,name);reset(f,1);
if ioresult=0 then size:=filesize(f) else isfile:=false;{-1}
end;
if isdisk then name:='Drive '+name;
if not isfile then name:='RAM under 1 MB'
else
getmem(buf,32768);
reload(0);
initloader:=name;
end;




end.